<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Dataflow: exemples</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia Version 2.1">
<META NAME="FORMATTER" CONTENT="Arachnophilia Version 2.1">
</HEAD>

<BODY BACKGROUND="" BGCOLOR="#0000ff" TEXT="#ffff00" LINK="#80ff80" VLINK="#c0c0c0" ALINK="#ff0000">

<CENTER><H1>Dataflow: exemples</H1>
</CENTER>
Vous avez vu probablement plusieurs fois un environnement de type "builder", par exemple Visual Basic, où on construit le "panneau frontal" d'une application avec des widgets : boutons, zones texte, menu déroulants, canevas avec des objets graphiques, etc. par le transport des widgets à partir d'une bibliothèque - boîte d'outils. <br>

Or, on peut construire de la même façon un <I>programme</I>. Voici l'exemple en Khoros, un excellent paquetage de programmation scientifique, notamment en traitement du signal et des images. La transformation de Fourier d'une image est naturellement codée par des procédures stockées dans la bibliothèque, mais il faut accessoirement souvent lire des données, générer les images filtrées, les spectres, etc. Le programme en Khoros a la forme suivante :
<p>
<CENTER><IMG SRC="img/khorwin.gif" ALT="">
</CENTER>
<P>

Le module "Phaser" est une procédure dont le contenu possède également une forme graphique.
Il suffit de cliquer  "Run", et l'interface commence à pomper les données, et en 3 secondes on obtient quelques résultats graphiques, par exemple
<p>
<IMG SRC="img/kh1.gif" ALT=""> et <IMG SRC="img/kh2.gif" ALT="">
<p>
dans des fenêtres indépendantes. Le grand panneau constitue <I>le programme</I>. Quand on le sauvegarde, l'interface génère un fichier textuel représentant les widgets, leur positions et leur liaisons avec les procédures exécutables qui traitent les données. (Ces procédures sont écrits en C, Perl ou Shell).

<p>
<hr>
<p>
La forme graphique du panneau dépend de l'implantation. Elle peut être austère, comme le montre l'exemple d'un programme de simulation en Matlab :
<p>
<IMG SRC="img/mtl1.gif" ALT="">, 
<p>

dont l'exécution crée et gère une fenêtre graphique : 
<p>
<IMG SRC="img/mtl2.gif" ALT="">,
<p>

légèrement plus coloré, mais - franchement - loin d'être au point, car les auteurs avaient d'autres soucis - comme en Scilab/SciCos :
<P>
<IMG SRC="img/scil1.gif" ALT="">,
<P>

ou avec un peu de baroque pseudo-3D comme en JavaStudio :
<P>
<IMG SRC="img/jast1.gif" ALT="">
<p>
Ce dernier exemple mérite un commentaire supplémentaire. En fait, le programmeur ne commence pas par mettre les boîtiers ici, mais sur une autre surface, le "panneau frontal" qui sera l'interface utilisateur (d'une application ou d'un applet Java). Le voici :
<P>
<IMG SRC="img/jast2.gif" ALT="">
<p>

En plaçant un widget comme le bouton, ou un menu déroulant sur le panneau, le boîtier est inséré dans le circuit automatiquement.

<p>
<hr>
<p>
Le dernier exemple appartient à LabView, un très populaire (parmi les physiciens) logiciel de simulation, et d'interfaçage avec l'équipement électronique extérieur. Ici les widgets sont des vrais petits instruments, des cadrans, oscillographes, thermomètres, etc. Voici le panneau et le programme visuel :
<p>
<IMG SRC="img/lav1.gif" ALT=""> &nbsp;
<IMG SRC="img/lav2.gif" ALT=""><p>

<p>
<hr>
<p>
Tout ceci doit inspirer l'étudiant, les détails seront discutés plus tard, et la partie programmation est brièvement décrite <A HREF="DIScheme.html">ici</A>.
<P>

Voici la situation concernant la disponibilité des logiciels mentionnés :
<UL>
<LI> Matlab (4 et 5) a été acheté. Nous en avons la licence et nous pouvons l'installer sur les stations NT. (Version Unix n'a pas été acheté, le prix est plutôt décourageant...)<p>

<LI> SciLab est gratuit, fonctionne sur toutes les plates-formes Unix populaires, ainsi que sur les NT. <FONT COLOR=#ff8000><b>C'est un fabuleux logiciel</b></FONT> produit par INRIA.<p>

<LI> JavaStudio est distribué gratuitement par SUN en sa version temporaire (30 jours). Je proposerai à la Commission de Moyens d'acheter l'environnement de développement chez SUN (dont l'avantage est qu'il est toujours mis à jour avec le langage et les librairies de support, et il est multi-plate-forme), pour l'instant aucune version n'est installée officiellement. Cela peut prendre
un peu de temps, dans notre maison chacun a ses propres idées à propos
des environnements du développement Java, et satisfaire tout le monde est
plutôt difficile...<p>

<LI> LabView également n'a pas été acheté, je possède une version d'évaluation de 30 jours.<p>

<LI> Il existe encore un autre logiciel, bien fait, adapté au
traitement des images, et performant : WiT. <br>
C'est un produit commercial,
on peut charger via Internet une version d'évaluation qui marche 10 heures.

</UL>

<p>
(Si quelqu'un est interessé par les adresses Web des distributeurs de ces
paquetages, prière de me le signaler.)


<p>
<FONT COLOR=#80ff00 face="Arial,Helvetica"><b>
Retour vers les <A HREF="Projets.html">Projets</A>.
</b></FONT>


</BODY>

</HTML>
